import { LoadedFragment } from "@graphql-codegen/visitor-plugin-common";
import { DepGraph } from "dependency-graph";
import { OperationDefinitionNode, FragmentDefinitionNode } from "graphql";
/** Find all FragmentDefinitionNode children. Dedup circles using a dependency graph. */
export declare function getFragments(fragments: Array<LoadedFragment>): FragmentDefinitionNode[];
/** Generate graph of names=>document content mappings. */
export declare function fragmentsGraph(fragments: LoadedFragment[]): DepGraph<LoadedFragment>;
/** Extract out all FragmentSpread names in children AST nodes. */
export declare function extractFragments(document: FragmentDefinitionNode | OperationDefinitionNode): string[];
