import { PLVariableInfo } from "./types";
export interface GenerateTraitOptions {
    native: boolean;
    nested: string;
    includeCompanion: boolean;
    includeCopy: boolean;
    includeApply: boolean;
    includeUnapply: boolean;
    /** When creating objects using js.Dynamic.literal, values must be js.Any.
     * Use this thunk to massage the value into the right expression.
     */
    dynamicValueConversion: (value: string) => string;
    extends: Array<string>;
    /** If defined, use this fqn in all places except trait and object declaration. */
    fqn?: string;
}
export declare const defaultOptions: GenerateTraitOptions;
/** Generate an object with some nested content. Very simple
 * model that is opaque to the child content.
 */
export declare function generateScalaObject(name: string, nested?: string | null): string;
/** Return an array with "extends" and "withs" property
 * inserted based on the order of the input parameter. You
 * still need to join the array with a space between: `rval.join(" ")`.
 */
export declare function createExtends(e: Array<string>): string[];
/** Generate a trait with a companion object and additional "helper"
 * methods. You can nest raw content via `nested`.
 */
export declare function generateScalaJSTrait(name: string, variables: Array<PLVariableInfo>, options?: Partial<GenerateTraitOptions>): string;
